<template>
  <div>
    <div class="flex justify-content-center">
      <div class="card mr-4">
        <h2 class="text-center">Mes informations</h2>
        <div class="p-fluid">
          <div class="field">
            <label for="name">Nom</label>
            <div class="p-float-label">
              <InputText id="name" type="text" placeholder="Nom" v-model="name" />
            </div>
          </div>
          <div class="field">
            <label for="surname">Prenom</label>
            <div class="p-float-label">
              <InputText
                id="surname"
                type="text"
                placeholder="Prenom"
                v-model="surname"
              />
            </div>
          </div>
          <div class="field">
            <label for="email">Email</label>
            <div class="p-float-label p-input-icon-right">
              <i class="pi pi-envelope" />
              <InputText
                id="email"
                type="email"
                placeholder="Adresse Mail"
                v-model="email"
                aria-describedby="email-error"
              />
            </div>
          </div>
          <Button
            :loading="generalLoading"
            @click="handleSubmit()"
            type="submit"
            label="Enregistrer"
            class="p-button-success"
          />
        </div>
      </div>

      <div class="card">
        <h2 class="text-center">Changer le mot de passe</h2>
        <div class="p-fluid">
          <div class="field">
            <label for="oldPwf">Ancien mot de passe</label>
            <div class="p-float-label">
              <InputText id="oldPwd" type="password" placeholder="Ancien mot de passe" v-model="oldPassword" />
            </div>
          </div>
          <div class="field">
            <label for="newPassword">Nouveau mot de passe</label>
            <div class="p-float-label">
              <InputText
                id="newPassword"
                type="password"
                placeholder="Nouveau mot de passe"
                v-model="newPassword"
              />
            </div>
          </div>
          <div class="field">
            <label for="confirmPassword">Confirmation mot de passe</label>
            <div class="p-float-label">
              <InputText
                id="confirmPassword"
                type="password"
                placeholder="Confirmation mot de passe"
                v-model="confirmPassword"
              />
            </div>
          </div>
          <p v-if="passwordError" class="errorForm">{{ passwordError }}</p>
          <Button
            :disabled="oldPassword.length == 0 || newPassword.length == 0 || confirmPassword != newPassword"
            :loading="passwordLoading"
            @click="handleSubmitPassword()"
            type="submit"
            label="Enregistrer"
            class="p-button-success"
          />
        </div>
      </div>
    </div>
    <div>
      <Button label="Retour" @click="$router.back()" class="mt-4" />

      <Dialog v-model:visible="visiblePassword">
        <template #header>
          <h3>Mot de passe modifié !</h3>
        </template>

        <div>
          <p>Votre mot de passe à bien été modifié</p>
        </div>

        <template #footer>
          <Button
            label="Fermer"
            class="p-button-primary"
            @click="visiblePassword = false"
          />
        </template>
      </Dialog>

      <Dialog v-model:visible="generalDialog">
        <template #header>
          <h3>informations modifiées !</h3>
        </template>

        <div>
          <p>Les informations de votre compte ont bien été modifiées</p>
        </div>

        <template #footer>
          <Button
            label="Fermer"
            class="p-button-primary"
            @click="generalDialog = false"
          />
        </template>
      </Dialog>
    </div>
  </div>
</template>

<script>
import InputText from "primevue/inputtext";
import Password from "primevue/password";
import Button from "primevue/button";
import Dialog from "primevue/dialog";
import axios from "axios";

export default {
  name: "Account",
  components: {
    InputText,
    Password,
    Dialog,
    Button,
  },
  data() {
    return {
      name: "",
      surname: "",
      email: "",
      login: "",
      password: "",
      submitted: false,
      showMessage: false,
      generalLoading: false,
      generalDialog: false,

      oldPassword: "",
      newPassword: "",
      confirmPassword: "",
      passwordError: null,
      passwordLoading: false,
      visiblePassword: false
    };
  },
  created() {
    if (this.$store.state.user.isLoggedIn) {
      this.name = this.$store.state.user.nom;
      this.email = this.$store.state.user.email;
      this.surname = this.$store.state.user.prenom;
      this.login = this.$store.state.user.login;
    } else {
      this.$router.push("/");
    }
  },
  methods: {
    async handleSubmitPassword() {
      this.passwordError = null
      this.passwordLoading = true
      if (this.newPassword.length > 0 && this.newPassword.length > 0 && this.confirmPassword.length > 0) {
        let validPassword = false
        await axios.post("/orthophonistes/connection", {login: this.$store.state.user.email, password: this.oldPassword}).then(res => {
          validPassword = true
        }).catch(err => {
          console.log(err)
        })
        if (validPassword) {
          if (this.newPassword == this.confirmPassword) {
            await axios.post("/orthophonistes/update/password", {login: this.$store.state.user.email, password: this.newPassword}).then(res => {
              this.oldPassword = ''
              this.newPassword = ""
              this.confirmPassword = ''
              this.visiblePassword = true
              this.passwordLoading = false
            }).catch(err => {
              console.log(err)
              this.passwordError = "Une erreur est survenue"
              this.passwordLoading = false
            })
          } else {
            this.passwordError = "Les mots de passe ne correspondent pas"
            this.passwordLoading = false
          }
        } else {
          this.passwordError = "Le mot de passe n'est pas le bon"
          this.passwordLoading = false
        }
      } else {
        this.passwordError = "Veuillez compléter tous les champs"
        this.passwordLoading = false
      }
    },
    async handleSubmit() {
      this.submitted = true;
      this.generalLoading = true
      if (this.name.length > 0 && this.email.length > 0 && this.surname.length > 0) {
        await axios
          .post("/orthophonistes/update", {
            nom: this.name,
            prenom: this.surname,
            login: this.login,
            email: this.email,
            grade: this.$store.state.user.grade,
            id: this.$store.state.user.id,
            enfants: [],
          })
          .then((res) => {
            this.$store.state.user.nom = this.nom;
            this.$store.state.user.prenom = this.surname;
            this.$store.state.user.email = this.email;
            this.generalDialog = true
            this.generalLoading = false
          })
          .catch((err) => {
            console.log(err);
          });
      } else {
        this.generalLoading = false
        alert("Form failed validation");
      }
      //this.toggleDialog();
    },
    toggleDialog() {
      this.showMessage = !this.showMessage;
      if (!this.showMessage) {
        this.resetForm();
      }
    },
    resetForm() {
      this.submitted = false;
    },
  },
};
</script>

<style lang="scss" scoped>
.card {
  margin-top: 2rem;
  padding: 2rem;
  border: 1px solid rgb(233, 236, 239);

  .field {
    margin-bottom: 2rem;
    text-align: left;
  }
}

.errorForm {
  color: red;
  font-size: 14px
}
</style>